Xerces-C++ 3.2.4

List of all members
DOMNode Class Referenceabstract

The `DOMNode` interface is the primary datatype for the entire Document Object Model. More...

`#include <xercesc/dom/DOMNode.hpp>`

Inheritance diagram for DOMNode:

## Public Types
Public Constants
enum | NodeType { ELEMENT_NODE = 1 , ATTRIBUTE_NODE = 2 , TEXT_NODE = 3 , CDATA_SECTION_NODE = 4 , ENTITY_REFERENCE_NODE = 5 , ENTITY_NODE = 6 , PROCESSING_INSTRUCTION_NODE = 7 , COMMENT_NODE = 8 , DOCUMENT_NODE = 9 , DOCUMENT_TYPE_NODE = 10 , DOCUMENT_FRAGMENT_NODE = 11 , NOTATION_NODE = 12 }
| NodeType. More...
enum | DocumentPosition { DOCUMENT_POSITION_DISCONNECTED = 0x01 , DOCUMENT_POSITION_PRECEDING = 0x02 , DOCUMENT_POSITION_FOLLOWING = 0x04 , DOCUMENT_POSITION_CONTAINS = 0x08 , DOCUMENT_POSITION_CONTAINED_BY = 0x10 , DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC = 0x20 }
| DocumentPosition: More...

## Public Member Functions
Destructor
virtual | ~DOMNode ()
| Destructor. More...
Functions introduced in DOM Level 1
virtual const XMLCh * | getNodeName () const =0
| The name of this node, depending on its type; see the table above. More...
virtual const XMLCh * | getNodeValue () const =0
| Gets the value of this node, depending on its type. More...
virtual NodeType | getNodeType () const =0
| An enum value representing the type of the underlying object. More...
virtual DOMNode * | getParentNode () const =0
| Gets the parent of this node. More...
virtual DOMNodeList * | getChildNodes () const =0
| Gets a `DOMNodeList` that contains all children of this node. More...
virtual DOMNode * | getFirstChild () const =0
| Gets the first child of this node. More...
virtual DOMNode * | getLastChild () const =0
| Gets the last child of this node. More...
virtual DOMNode * | getPreviousSibling () const =0
| Gets the node immediately preceding this node. More...
virtual DOMNode * | getNextSibling () const =0
| Gets the node immediately following this node. More...
virtual DOMNamedNodeMap * | getAttributes () const =0
| Gets a `DOMNamedNodeMap` containing the attributes of this node (if it is an `DOMElement`) or `null` otherwise. More...
virtual DOMDocument * | getOwnerDocument () const =0
| Gets the `DOMDocument` object associated with this node. More...
virtual DOMNode * | cloneNode (bool deep) const =0
| Returns a duplicate of this node. More...
virtual DOMNode * | insertBefore (DOMNode *newChild, DOMNode *refChild)=0
| Inserts the node `newChild` before the existing child node `refChild`. More...
virtual DOMNode * | replaceChild (DOMNode *newChild, DOMNode *oldChild)=0
| Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. More...
virtual DOMNode * | removeChild (DOMNode *oldChild)=0
| Removes the child node indicated by `oldChild` from the list of children, and returns it. More...
virtual DOMNode * | appendChild (DOMNode *newChild)=0
| Adds the node `newChild` to the end of the list of children of this node. More...
virtual bool | hasChildNodes () const =0
| This is a convenience method to allow easy determination of whether a node has any children. More...
virtual void | setNodeValue (const XMLCh *nodeValue)=0
| Sets the value of the node. More...
Functions introduced in DOM Level 2.
virtual void | normalize ()=0
| Puts all `DOMText` nodes in the full depth of the sub-tree underneath this `DOMNode`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOMText` nodes, i.e., there are neither adjacent `DOMText` nodes nor empty `DOMText` nodes. More...
virtual bool | isSupported (const XMLCh *feature, const XMLCh *version) const =0
| Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. More...
virtual const XMLCh * | getNamespaceURI () const =0
| Get the namespace URI of this node, or `null` if it is unspecified. More...
virtual const XMLCh * | getPrefix () const =0
| Get the namespace prefix of this node, or `null` if it is unspecified. More...
virtual const XMLCh * | getLocalName () const =0
| Returns the local part of the qualified name of this node. More...
virtual void | setPrefix (const XMLCh *prefix)=0
| Set the namespace prefix of this node. More...
virtual bool | hasAttributes () const =0
| Returns whether this node (if it is an element) has any attributes. More...
Functions introduced in DOM Level 3.
virtual bool | isSameNode (const DOMNode *other) const =0
| Returns whether this node is the same node as the given one. More...
virtual bool | isEqualNode (const DOMNode *arg) const =0
| Tests whether two nodes are equal. More...
virtual void * | setUserData (const XMLCh *key, void *data, DOMUserDataHandler *handler)=0
| Associate an object to a key on this node. More...
virtual void * | getUserData (const XMLCh *key) const =0
| Retrieves the object associated to a key on a this node. More...
virtual const XMLCh * | getBaseURI () const =0
| The absolute base URI of this node or `null` if undefined. More...
virtual short | compareDocumentPosition (const DOMNode *other) const =0
| Compares the reference node, i.e. More...
virtual const XMLCh * | getTextContent () const =0
| WARNING: This method is known to be buggy and does not produce accurate results under a variety of conditions. More...
virtual void | setTextContent (const XMLCh *textContent)=0
| This attribute removes any possible children this node may have and, if the new string is not empty or null, replaced by a single `DOMText` node containing the string this attribute is set to. More...
virtual const XMLCh * | lookupPrefix (const XMLCh *namespaceURI) const =0
| Look up the prefix associated to the given namespace URI, starting from this node. More...
virtual bool | isDefaultNamespace (const XMLCh *namespaceURI) const =0
| This method checks if the specified `namespaceURI` is the default namespace or not. More...
virtual const XMLCh * | lookupNamespaceURI (const XMLCh *prefix) const =0
| Look up the namespace URI associated to the given prefix, starting from this node. More...
virtual void * | getFeature (const XMLCh *feature, const XMLCh *version) const =0
| This method makes available a `DOMNode`'s specialized interface. More...
Non-standard Extension
virtual void | release ()=0
| Called to indicate that this Node (and its associated children) is no longer in use and that the implementation may relinquish any resources associated with it and its associated children. More...

## Protected Member Functions
Hidden constructors
| DOMNode ()
| DOMNode (const DOMNode &)

## Detailed Description

The `DOMNode` interface is the primary datatype for the entire Document Object Model.

It represents a single node in the document tree. While all objects implementing the `DOMNode` interface expose methods for dealing with children, not all objects implementing the `DOMNode` interface may have children. For example, `DOMText` nodes may not have children, and adding children to such nodes results in a `DOMException` being raised.

The attributes `nodeName`, `nodeValue` and `attributes` are included as a mechanism to get at node information without casting down to the specific derived interface. In cases where there is no obvious mapping of these attributes for a specific `nodeType` (e.g., `nodeValue` for an `DOMElement` or `attributes` for a `DOMComment` ), this returns `null`. Note that the specialized interfaces may contain additional and more convenient mechanisms to get and set the relevant information.

The values of `nodeName`, `nodeValue`, and `attributes` vary according to the node type as follows:

Interface | nodeName | nodeValue | attributes
DOMAttr | name of attribute | value of attribute | null
DOMCDATASection | "#cdata-section" | content of the CDATA Section | null
DOMComment | "#comment" | content of the comment | null
DOMDocument | "#document" | null | null
DOMDocumentFragment | "#document-fragment" | null | null
DOMDocumentType | document type name | null | null
DOMElement | tag name | null | NamedNodeMap
DOMEntity | entity name | null | null
DOMEntityReference | name of entity referenced | null | null
DOMNotation | notation name | null | null
DOMProcessingInstruction | target | entire content excluding the target | null
DOMText | "#text" | content of the text node | null

See also the Document Object Model (DOM) Level 2 Core Specification.

Since
  DOM Level 1

## Member Enumeration Documentation

## ◆ DocumentPosition

enum DOMNode::DocumentPosition

DocumentPosition:

`DOCUMENT_POSITION_CONTAINED_BY:` The node is contained by the reference node. A node which is contained is always following, too.

`DOCUMENT_POSITION_CONTAINS:` The node contains the reference node. A node which contains is always preceding, too.

`DOCUMENT_POSITION_DISCONNECTED:` The two nodes are disconnected. Order between disconnected nodes is always implementation-specific.

`DOCUMENT_POSITION_FOLLOWING:` The node follows the reference node.

`DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC:` The determination of preceding versus following is implementation-specific.

`DOCUMENT_POSITION_PRECEDING:` The second node precedes the reference node.

Since
  DOM Level 3

Enumerator
DOCUMENT_POSITION_DISCONNECTED |
DOCUMENT_POSITION_PRECEDING |
DOCUMENT_POSITION_FOLLOWING |
DOCUMENT_POSITION_CONTAINS |
DOCUMENT_POSITION_CONTAINED_BY |
DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC |

## ◆ NodeType

enum DOMNode::NodeType

NodeType.

Since
  DOM Level 1

Enumerator
ELEMENT_NODE |
ATTRIBUTE_NODE |
TEXT_NODE |
CDATA_SECTION_NODE |
ENTITY_REFERENCE_NODE |
ENTITY_NODE |
PROCESSING_INSTRUCTION_NODE |
COMMENT_NODE |
DOCUMENT_NODE |
DOCUMENT_TYPE_NODE |
DOCUMENT_FRAGMENT_NODE |
NOTATION_NODE |

## Constructor & Destructor Documentation

## ◆ DOMNode() [1/2]

DOMNode::DOMNode | ( |  | ) |
| protected

## ◆ DOMNode() [2/2]

DOMNode::DOMNode | ( | const DOMNode & |  | ) |
| protected

## ◆ ~DOMNode()

virtual DOMNode::~DOMNode | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ appendChild()

virtual DOMNode * DOMNode::appendChild | ( | DOMNode * | newChild | ) |
| pure virtual

Adds the node `newChild` to the end of the list of children of this node.

If the `newChild` is already in the tree, it is first removed.

Parameters

  newChild | The node to add.If it is a `DOMDocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node

Returns
  The node added.

Exceptions

  DOMException | HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to append is one of this node's ancestors. WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node. NO_MODIFICATION_ALLOWED_ERR: Raised if this node or the node being appended is readonly.

Since
  DOM Level 1

## ◆ cloneNode()

virtual DOMNode * DOMNode::cloneNode | ( | bool | deep | ) | const
| pure virtual

Returns a duplicate of this node.

This function serves as a generic copy constructor for nodes.

The duplicate node has no parent ( `parentNode` returns `null`.).
Cloning an `DOMElement` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `DOMText` node. Cloning any other type of node simply returns a copy of this node.

Parameters

  deep | If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `DOMElement`).

Returns
  The duplicate node.

Since
  DOM Level 1

## ◆ compareDocumentPosition()

virtual short DOMNode::compareDocumentPosition | ( | const DOMNode * | other | ) | const
| pure virtual

Compares the reference node, i.e.

the node on which this method is being called, with a node, i.e. the one passed as a parameter, with regard to their position in the document and according to the document order.

Parameters

  other | The node to compare against this node.

Returns
  Returns how the given node is positioned relatively to this node.

Since
  DOM Level 3

## ◆ getAttributes()

virtual DOMNamedNodeMap * DOMNode::getAttributes | ( |  | ) | const
| pure virtual

Gets a `DOMNamedNodeMap` containing the attributes of this node (if it is an `DOMElement`) or `null` otherwise.

Since
  DOM Level 1

## ◆ getBaseURI()

virtual const XMLCh * DOMNode::getBaseURI | ( |  | ) | const
| pure virtual

The absolute base URI of this node or `null` if undefined.

This value is computed according to . However, when the `DOMDocument` supports the feature "HTML" , the base URI is computed using first the value of the href attribute of the HTML BASE element if any, and the value of the `documentURI` attribute from the `DOMDocument` interface otherwise.

When the node is an `DOMElement`, a `DOMDocument` or a a `DOMProcessingInstruction`, this attribute represents the properties [base URI] defined in . When the node is a `DOMNotation`, an `DOMEntity`, or an `DOMEntityReference`, this attribute represents the properties [declaration base URI].

Since
  DOM Level 3

## ◆ getChildNodes()

virtual DOMNodeList * DOMNode::getChildNodes | ( |  | ) | const
| pure virtual

Gets a `DOMNodeList` that contains all children of this node.

If there are no children, this is a `DOMNodeList` containing no nodes. The content of the returned `DOMNodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `DOMNodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `DOMNodeList`, including the ones returned by the `getElementsByTagName` method.

Since
  DOM Level 1

## ◆ getFeature()

virtual void * DOMNode::getFeature | ( | const XMLCh * | feature,
|  | const XMLCh * | version
| ) |  | const
| pure virtual

This method makes available a `DOMNode`'s specialized interface.

Parameters

  feature | The name of the feature requested (case-insensitive).
  version | The version of the feature requested.

Returns
  Returns an alternate `DOMNode` which implements the specialized APIs of the specified feature, if any, or `null` if there is no alternate `DOMNode` which implements interfaces associated with that feature. Any alternate `DOMNode` returned by this method must delegate to the primary core `DOMNode` and not return results inconsistent with the primary core `DOMNode` such as `key`, `attributes`, `childNodes`, etc.

Since
  DOM Level 3

## ◆ getFirstChild()

virtual DOMNode * DOMNode::getFirstChild | ( |  | ) | const
| pure virtual

Gets the first child of this node.

If there is no such node, this returns `null`.

Since
  DOM Level 1

## ◆ getLastChild()

virtual DOMNode * DOMNode::getLastChild | ( |  | ) | const
| pure virtual

Gets the last child of this node.

If there is no such node, this returns `null`.

Since
  DOM Level 1

## ◆ getLocalName()

virtual const XMLCh * DOMNode::getLocalName | ( |  | ) | const
| pure virtual

Returns the local part of the qualified name of this node.

For nodes created with a DOM Level 1 method, such as `createElement` from the `DOMDocument` interface, it is null.

Since
  DOM Level 2

## ◆ getNamespaceURI()

virtual const XMLCh * DOMNode::getNamespaceURI | ( |  | ) | const
| pure virtual

Get the namespace URI of this node, or `null` if it is unspecified.

This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.

For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `DOMDocument` interface, this is always `null`.

Since
  DOM Level 2

## ◆ getNextSibling()

virtual DOMNode * DOMNode::getNextSibling | ( |  | ) | const
| pure virtual

Gets the node immediately following this node.

If there is no such node, this returns `null`.

Since
  DOM Level 1

## ◆ getNodeName()

virtual const XMLCh * DOMNode::getNodeName | ( |  | ) | const
| pure virtual

The name of this node, depending on its type; see the table above.

Since
  DOM Level 1

## ◆ getNodeType()

virtual NodeType DOMNode::getNodeType | ( |  | ) | const
| pure virtual

An enum value representing the type of the underlying object.

Since
  DOM Level 1

## ◆ getNodeValue()

virtual const XMLCh * DOMNode::getNodeValue | ( |  | ) | const
| pure virtual

Gets the value of this node, depending on its type.

Exceptions

  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.

Since
  DOM Level 1

## ◆ getOwnerDocument()

virtual DOMDocument * DOMNode::getOwnerDocument | ( |  | ) | const
| pure virtual

Gets the `DOMDocument` object associated with this node.

This is also the `DOMDocument` object used to create new nodes. When this node is a `DOMDocument` or a `DOMDocumentType` which is not used with any `DOMDocument` yet, this is `null`.

Since
  DOM Level 1

## ◆ getParentNode()

virtual DOMNode * DOMNode::getParentNode | ( |  | ) | const
| pure virtual

Gets the parent of this node.

All nodes, except `DOMDocument`, `DOMDocumentFragment`, and `DOMAttr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, a `null` DOMNode is returned.

Since
  DOM Level 1

## ◆ getPrefix()

virtual const XMLCh * DOMNode::getPrefix | ( |  | ) | const
| pure virtual

Get the namespace prefix of this node, or `null` if it is unspecified.

Since
  DOM Level 2

## ◆ getPreviousSibling()

virtual DOMNode * DOMNode::getPreviousSibling | ( |  | ) | const
| pure virtual

Gets the node immediately preceding this node.

If there is no such node, this returns `null`.

Since
  DOM Level 1

## ◆ getTextContent()

virtual const XMLCh * DOMNode::getTextContent | ( |  | ) | const
| pure virtual

WARNING: This method is known to be buggy and does not produce accurate results under a variety of conditions.

This attribute returns the text content of this node and its descendants. No serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed and the returned string does not contain the white spaces in element content.

The string returned is made of the text content of this node depending on its type, as defined below:

Node type | Content
ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

Exceptions

  DOMException | DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

See also
  setTextContent

Since
  DOM Level 3

## ◆ getUserData()

virtual void * DOMNode::getUserData | ( | const XMLCh * | key | ) | const
| pure virtual

Retrieves the object associated to a key on a this node.

The object must first have been set to this node by calling `setUserData` with the same key.

Parameters

  key | The key the object is associated to.

Returns
  Returns the `void*` associated to the given key on this node, or `null` if there was none.

See also
  setUserData

Since
  DOM Level 3

## ◆ hasAttributes()

virtual bool DOMNode::hasAttributes | ( |  | ) | const
| pure virtual

Returns whether this node (if it is an element) has any attributes.

Returns
  `true` if this node has any attributes, `false` otherwise.

Since
  DOM Level 2

## ◆ hasChildNodes()

virtual bool DOMNode::hasChildNodes | ( |  | ) | const
| pure virtual

This is a convenience method to allow easy determination of whether a node has any children.

Returns
  `true` if the node has any children, `false` if the node has no children.

Since
  DOM Level 1

## ◆ insertBefore()

virtual DOMNode * DOMNode::insertBefore | ( | DOMNode * | newChild,
|  | DOMNode * | refChild
| ) |  |
| pure virtual

Inserts the node `newChild` before the existing child node `refChild`.

If `refChild` is `null`, insert `newChild` at the end of the list of children.
If `newChild` is a `DOMDocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed. Note that a `DOMNode` that has never been assigned to refer to an actual node is == null.

Parameters

  newChild | The node to insert.
  refChild | The reference node, i.e., the node before which the new node must be inserted.

Returns
  The node being inserted.

Exceptions

  DOMException | HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to insert is one of this node's ancestors. WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node. NO_MODIFICATION_ALLOWED_ERR: Raised if this node or the node being inserted is readonly. NOT_FOUND_ERR: Raised if `refChild` is not a child of this node.

Since
  DOM Level 1

## ◆ isDefaultNamespace()

virtual bool DOMNode::isDefaultNamespace | ( | const XMLCh * | namespaceURI | ) | const
| pure virtual

This method checks if the specified `namespaceURI` is the default namespace or not.

Parameters

  namespaceURI | The namespace URI to look for.

Returns
  `true` if the specified `namespaceURI` is the default namespace, `false` otherwise.

Since
  DOM Level 3

## ◆ isEqualNode()

virtual bool DOMNode::isEqualNode | ( | const DOMNode * | arg | ) | const
| pure virtual

Tests whether two nodes are equal.

This method tests for equality of nodes, not sameness (i.e., whether the two nodes are pointers to the same object) which can be tested with `DOMNode::isSameNode`. All nodes that are the same will also be equal, though the reverse may not be true.
Two nodes are equal if and only if the following conditions are satisfied: The two nodes are of the same type.The following string attributes are equal: `nodeName`, `localName`, `namespaceURI`, `prefix`, `nodeValue` , `baseURI`. This is: they are both `null`, or they have the same length and are character for character identical. The `attributes` `DOMNamedNodeMaps` are equal. This is: they are both `null`, or they have the same length and for each node that exists in one map there is a node that exists in the other map and is equal, although not necessarily at the same index.The `childNodes` `DOMNodeLists` are equal. This is: they are both `null`, or they have the same length and contain equal nodes at the same index. This is true for `DOMAttr` nodes as for any other type of node. Note that normalization can affect equality; to avoid this, nodes should be normalized before being compared.
For two `DOMDocumentType` nodes to be equal, the following conditions must also be satisfied: The following string attributes are equal: `publicId`, `systemId`, `internalSubset`.The `entities` `DOMNamedNodeMaps` are equal.The `notations` `DOMNamedNodeMaps` are equal.
On the other hand, the following do not affect equality: the `ownerDocument` attribute, the `specified` attribute for `DOMAttr` nodes, the `isWhitespaceInElementContent` attribute for `DOMText` nodes, as well as any user data or event listeners registered on the nodes.

Parameters

  arg | The node to compare equality with.

Returns
  If the nodes, and possibly subtrees are equal, `true` otherwise `false`.

Since
  DOM Level 3

## ◆ isSameNode()

virtual bool DOMNode::isSameNode | ( | const DOMNode * | other | ) | const
| pure virtual

Returns whether this node is the same node as the given one.

This method provides a way to determine whether two `DOMNode` references returned by the implementation reference the same object. When two `DOMNode` references are references to the same object, even if through a proxy, the references may be used completely interchangeably, such that all attributes have the same values and calling the same DOM method on either reference always has exactly the same effect.

Parameters

  other | The node to test against.

Returns
  Returns `true` if the nodes are the same, `false` otherwise.

Since
  DOM Level 3

## ◆ isSupported()

virtual bool DOMNode::isSupported | ( | const XMLCh * | feature,
|  | const XMLCh * | version
| ) |  | const
| pure virtual

Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

Parameters

  feature | The string of the feature to test. This is the same name as what can be passed to the method `hasFeature` on `DOMImplementation`.
  version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.

Returns
  Returns `true` if the specified feature is supported on this node, `false` otherwise.

Since
  DOM Level 2

## ◆ lookupNamespaceURI()

virtual const XMLCh * DOMNode::lookupNamespaceURI | ( | const XMLCh * | prefix | ) | const
| pure virtual

Look up the namespace URI associated to the given prefix, starting from this node.

Parameters

  prefix | The prefix to look for. If this parameter is `null`, the method will return the default namespace URI if any.

Returns
  Returns the associated namespace URI or `null` if none is found.

Since
  DOM Level 3

## ◆ lookupPrefix()

virtual const XMLCh * DOMNode::lookupPrefix | ( | const XMLCh * | namespaceURI | ) | const
| pure virtual

Look up the prefix associated to the given namespace URI, starting from this node.

The default namespace declarations are ignored by this method.

Parameters

  namespaceURI | The namespace URI to look for.

Returns
  Returns an associated namespace prefix if found, `null` if none is found. If more than one prefix are associated to the namespace prefix, the returned namespace prefix is implementation dependent.

Since
  DOM Level 3

## ◆ normalize()

virtual void DOMNode::normalize | ( |  | ) |
| pure virtual

Puts all `DOMText` nodes in the full depth of the sub-tree underneath this `DOMNode`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOMText` nodes, i.e., there are neither adjacent `DOMText` nodes nor empty `DOMText` nodes.

This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains `DOMCDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `DOMText` nodes and `DOMCDATASection` nodes.

Since
  DOM Level 2

## ◆ release()

virtual void DOMNode::release | ( |  | ) |
| pure virtual

Called to indicate that this Node (and its associated children) is no longer in use and that the implementation may relinquish any resources associated with it and its associated children.

If this is a document, any nodes it owns (created by DOMDocument::createXXXX()) are also released.

Access to a released object will lead to unexpected result.

Exceptions

  DOMException | INVALID_ACCESS_ERR: Raised if this Node has a parent and thus should not be released yet.

## ◆ removeChild()

virtual DOMNode * DOMNode::removeChild | ( | DOMNode * | oldChild | ) |
| pure virtual

Removes the child node indicated by `oldChild` from the list of children, and returns it.

Parameters

  oldChild | The node being removed.

Returns
  The node removed.

Exceptions

  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

Since
  DOM Level 1

## ◆ replaceChild()

virtual DOMNode * DOMNode::replaceChild | ( | DOMNode * | newChild,
|  | DOMNode * | oldChild
| ) |  |
| pure virtual

Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.

If `newChild` is a `DOMDocumentFragment` object, `oldChild` is replaced by all of the `DOMDocumentFragment` children, which are inserted in the same order.

If the `newChild` is already in the tree, it is first removed.

Parameters

  newChild | The new node to put in the child list.
  oldChild | The node being replaced in the list.

Returns
  The node replaced.

Exceptions

  DOMException | HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or it the node to put in is one of this node's ancestors. WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node. NO_MODIFICATION_ALLOWED_ERR: Raised if this node or the new node is readonly. NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

Since
  DOM Level 1

## ◆ setNodeValue()

virtual void DOMNode::setNodeValue | ( | const XMLCh * | nodeValue | ) |
| pure virtual

Sets the value of the node.

Any node which can have a nodeValue will also accept requests to set it to a string. The exact response to this varies from node to node – Attribute, for example, stores its values in its children and has to replace them with a new Text holding the replacement value.

For most types of Node, value is null and attempting to set it will throw DOMException(NO_MODIFICATION_ALLOWED_ERR). This will also be thrown if the node is read-only.

See also
  getNodeValue

Since
  DOM Level 1

## ◆ setPrefix()

virtual void DOMNode::setPrefix | ( | const XMLCh * | prefix | ) |
| pure virtual

Set the namespace prefix of this node.

Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `DOMElement` and `DOMAttr` interfaces, when applicable.

Note also that changing the prefix of an attribute, that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.

Parameters

  prefix | The prefix of this node.

Exceptions

  DOMException | INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NAMESPACE_ERR: Raised if the specified `prefix` is malformed, if the `namespaceURI` of this node is `null`, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if this node is an attribute and the specified prefix is "xmlns" and the `namespaceURI` of this node is different from "http://www.w3.org/2000/xmlns/", or if this node is an attribute and the `qualifiedName` of this node is "xmlns".

Since
  DOM Level 2

## ◆ setTextContent()

virtual void DOMNode::setTextContent | ( | const XMLCh * | textContent | ) |
| pure virtual

This attribute removes any possible children this node may have and, if the new string is not empty or null, replaced by a single `DOMText` node containing the string this attribute is set to.

No parsing is performed, the input string is taken as pure textual content.

Exceptions

  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.

See also
  getTextContent

Since
  DOM Level 3

## ◆ setUserData()

virtual void * DOMNode::setUserData | ( | const XMLCh * | key,
|  | void * | data,
|  | DOMUserDataHandler * | handler
| ) |  |
| pure virtual

Associate an object to a key on this node.

The object can later be retrieved from this node by calling `getUserData` with the same key.

Deletion of the user data remains the responsibility of the application program; it will not be automatically deleted when the nodes themselves are reclaimed.

Both the parameter `data` and the returned object are void pointer, it is applications' responsibility to keep track of their original type. Casting them to the wrong type may result unexpected behavior.

Parameters

  key | The key to associate the object to.
  data | The object to associate to the given key, or `null` to remove any existing association to that key.
  handler | The handler to associate to that key, or `null`.

Returns
  Returns the void* object previously associated to the given key on this node, or `null` if there was none.

See also
  getUserData

Since
  DOM Level 3

The documentation for this class was generated from the following file:

- DOMNode.hpp